import { CoreClient } from '../../client';
import { Stream } from '../../client/common-typings';
import { EventData, ResultData } from '../../client/api-core-typings';
declare type Options = {
    token: string;
    client: CoreClient;
};
declare class Application {
    api: CoreClient;
    private token;
    private client;
    constructor(options: Options);
    whenEvent(event: Event, task: Task): Promise<Stream<EventData>>;
    whenResult(result: Result, task: Task): Promise<Stream<ResultData>>;
    private executeTask;
    private startService;
}
declare type Event = {
    serviceID: string;
    filter?: string;
};
declare type Result = {
    serviceID: string;
    task?: string;
    output?: string;
};
declare type Task = {
    serviceID: string;
    taskKey: string;
    inputs?: any;
};
export default Application;
export { Options, Event, Result, Task };
