import * as grpc from 'grpc'
import * as path from 'path'
import ServiceClient from './api-service-typings'
import CoreClient from './api-core-typings'

type Options = {
    endpoint: string
}

class ClientBuilder {
    private options: Options;

    constructor(options: Options){
        this.options = options;
    }

    service(): ServiceClient {
        const proto = grpc.load(path.join(__dirname, './proto/api-service.proto'));
        const clientConstructor = proto.api.Service;
        return <ServiceClient>new clientConstructor(
            this.options.endpoint,
            grpc.credentials.createInsecure()
        )
    }

    core(): CoreClient {
        const proto = grpc.load(path.join(__dirname, './proto/api-core.proto'));
        const clientConstructor = proto.api.Core;
        return <CoreClient>new clientConstructor(
            this.options.endpoint,
            grpc.credentials.createInsecure()
        )
    }
}

export default ClientBuilder;